FUNCTION interp_surf(Model, n, f) RESULT(g)

USE DefUtils
IMPLICIT NONE
TYPE(Model_t) :: Model
INTEGER :: n,i,k,nb
REAL(KIND=dp) :: f, g
logical :: first_time=.true.
real,dimension(1325,2) :: data_l


save first_time,nb,data_l


if (first_time) then
  first_time=.false.
  nb=0
  open(1,file='Data/SurfTopo.dat')
  do i=1,1325
    read(1,*) data_l(i,1),data_l(i,2)
	nb=nb+1
	
  enddo
  close(1)

endif

k=0

do i=1,nb
if (data_l(i,1)>f) then
k=i
exit
endif
enddo


if (k==0) then
k=nb
g=data_l(k,2)
else
g=((f-data_l(k-1,1))*data_l(k,2)+(data_l(k,1)-f)*data_l(k-1,2))/(data_l(k,1)-data_l(k-1,1))
endif



END FUNCTION interp_surf

FUNCTION interp_bed(Model, n, f) RESULT(g)

USE DefUtils
IMPLICIT NONE
TYPE(Model_t) :: Model
INTEGER :: n,i,k,nb
REAL(KIND=dp) :: f, g
logical :: first_time=.true.
real,dimension(1325,2) :: data_l


save first_time,nb,data_l

if (first_time) then
  first_time=.false.
  nb=0
  open(1,file='Data/BedTopo.dat')
  do i=1,1325
    read(1,*) data_l(i,1),data_l(i,2)
	nb=nb+1
	
  enddo
  close(1)

endif

k=0

do i=1,nb
if (data_l(i,1)>f) then
k=i
exit
endif
enddo

if (k==0) then
k=nb
g=data_l(k,2)
else
g=((f-data_l(k-1,1))*data_l(k,2)+(data_l(k,1)-f)*data_l(k-1,2))/(data_l(k,1)-data_l(k-1,1))
endif

END FUNCTION interp_bed

FUNCTION glen_law(Model, n, f) RESULT(g)
USE DefUtils
IMPLICIT NONE

TYPE(Model_t) :: Model
TYPE(Variable_t), POINTER :: W
INTEGER :: n,i,j,k,cont
REAL(KIND=dp) :: f, g, water



W => VariableGet( Model % Variables, 'Water Content')
f=f+273.15


IF (f<263.15) THEN
g=15.47*exp(-(6.0e4/8.314)*(1/f-1/263.15))
ELSE
g=15.47*exp(-(13.9e4/8.314)*(1/f-1/263.15))
ENDIF

!Taking into account water content for viscosity:(llibouty et duval, 1985)

water=W % values (W % perm (n))

if (water>0.03) then
water = 0.03
endif

g=g*(1.0 + water*1.84 )
g=(2.0*g)**(-1.0/3.0)

END FUNCTION glen_law

FUNCTION diffusivity_calc(Model, n, f) RESULT(g)
USE DefUtils
IMPLICIT NONE
TYPE(Model_t) :: Model
TYPE(Variable_t), POINTER :: Dens
INTEGER :: n,i,j,nb,k,cont
REAL(KIND=dp) :: f, g, d


Dens => VariableGet( Model % Variables, 'Densi')
d=Dens % values (Dens % perm (n))

  g=0.0000025*d**2-0.000123*d+0.024

  g=g*(9.828*exp(-5.7e-3*(f+273.15)))/2.1*3600.0*24*365.25
  g=g/(146.3+7.253*(f+273.15))



END FUNCTION diffusivity_calc
